#include <afxdb.h>
#include "ClienteRs.h"
#include <iostream.h>


char getOption( char *options )
{
	char dummy[10];
	cout << options << " -> ";
	cin.getline( dummy, 10 );
	return dummy[0];
}

void modify( CClienteRs& cli )
{
	cli.Edit();
	
	char str[ CClienteRs::MAXSTRLEN + 1 ];
	
	cout << "----------------------------------" << endl;
	
	cout << "Nome\t\t";   
	cin.getline( str, CClienteRs::MAXSTRLEN+1 ); 
	if ( *str != '\0' ) cli.m_sNome = str;
	
	cout << "Morada\t\t"; 
	cin.getline( str, CClienteRs::MAXSTRLEN+1 ); 
	if ( *str != '\0' ) cli.m_sMorada = str;
	
	cout << "Telefone\t"; 
	cin.getline( str, CClienteRs::MAXSTRLEN+1 ); 
	if ( *str != '\0' ) cli.m_sTelefone = str;
	
	cout << "Fax\t\t";    
	cin.getline( str, CClienteRs::MAXSTRLEN+1 ); 
	if ( *str != '\0' ) cli.m_sFax = str;
	
	cout << "E-Mail\t\t"; 
	cin.getline( str, CClienteRs::MAXSTRLEN+1 ); 
	if ( *str != '\0' ) cli.m_sEmail = str;
	
	cli.Update();
}

void process( CClienteRs& rs )
{
	char op = '\0';
	
	while ( op != 'q' )
	{
		if ( !rs.IsEOF() )
			cout << rs;
		
		op = getOption( 
			"(Q)uit (N)ext (P)rev (F)irst (L)ast (D)elete (A)dd (C)hange" );
		
		switch( op ) {
		case 'n' : // Move para o prximo registo
			rs.MoveNext();
			if ( rs.IsEOF() ) rs.MovePrev();
			break;
		case 'p' : // Move para o registo anterior
			rs.MovePrev();
			if ( rs.IsBOF() ) rs.MoveNext();
			break;
		case 'f' : // Move para o primeiro registo
			rs.MoveFirst();
			break;
		case 'l' : // Move para o ltimo registo
			rs.MoveLast();
			break;
		case 'd' : // Remove o registo actual
			try
			{
				rs.Delete();
				rs.MoveNext();
				if ( rs.IsEOF() ) rs.MoveLast();
				if ( rs.IsBOF() ) rs.SetFieldNull(NULL);
			}
			catch ( CDBException e )
			{
				cerr << e.m_strError << endl;
			}
			break;
		case 'a' : // Adiciona um novo registo
			try
			{
				rs.AddNew();
				cin >> rs;
				rs.Update();
				rs.MoveLast();
			}
			catch ( CDBException e )
			{
				cerr << e.m_strError << endl;
			}
			break;
		case 'c' : // Modifica o registo actual
			try
			{
				modify( rs );
			}
			catch ( CDBException e )
			{
				cerr << e.m_strError << endl;
			}
			break;
		}
	}
}

void main()
{
	CDatabase db;
	BOOL bRet;

	bRet=db.Open( _T("bdMFCx"), FALSE, FALSE, "ODBC;", FALSE );
	//bRet=db.OpenEx( _T("DSN=bdMFC;UID=;PWD=") ); // com utilizao de connection string
	//bRet=db.OpenEx( NULL ); //  pedido para seleccionar o DSN 
	
	CClienteRs rsCli( &db );

	rsCli.Open( CRecordset::dynaset );
	
	process( rsCli );
	
	rsCli.Close();

	db.Close();
}


